This archive contains all modifications I had to do in order to compile
BINKD 0.9.3h for Win32 with RSXNT, and an instruction on how to do this.

You need the following things:

- binkd 0.9.3h source, available at
  http://www.physcip.uni-stuttgart.de/tobi/binkd/bd093h.zip
- binkd 0.9.3h CRC32 patches, available at
  http://www.physcip.uni-stuttgart.de/tobi/binkd/binkdcrc.zip
- The RSXNT compiler, version 1.50 (other versions, newer or older,
  probably won't do), available at
  http://www.mathematik.uni-bielefeld.de/~rainer
- A GNU patch program for Windows NT. Don't ask me where to get this -
  I store my sources on a Samba server and ran the patch program on Unix ...
- GNU make for Windows NT. Again, don't ask me, I just have an executable
  floating around somewhere on my LAN server ...

First, apply the CRC32 patches as outlined in the README file which can be
found in binkdcrc.zip.  This should not be a problem once you find a working
GNU patch.

Compiling binkd with RSXNT poses two major problems.  The one is that the
sequence "f=fopen(...); fstat(fileno(f), &sb)" does not work with RSXNT (it
yields "permission denied").  Therefore I have modified the binkd source code
to do a "stat" before the fopen.  These changes are contianed in the file
"patch-rsx".  Copy it into the binkd source code directory (binkd-0.9.3h) and
apply it using

   patch -p1 < patch-rsx

The next problem with RSXNT is that winsock.h as supplied with RSXNT 1.50
cannot coexist with EMX include files, esp. sys/types.h and sys/params.h.
You'll get all sorts of errors when including both sys/types.h and winsock.h.
Some obvious, some hidden.  I have really tried to work around this in the
binkd source somehow, but I did not manage to do it.  Therefore, you have to
patch the include files from EMX and RSXNT themselves.  (Don't worry, this
won't break other programs, I have surrended all changes with
#ifdef RSXNTWINSOCK). Proceed as follows:

  - Copy paramh.dif and typesh.dif to \emx\include\sys
  - Apply them by changing to \emx\include\sys and using
    "patch -p1 <typesh.dif" and "patch -p1 <paramh.dif>"
  - Copy winsockh.dif to \rsxnt\include\win32
  - Apply by chaning to \rsxnt\include\win32 and using
    "patch -p1 <winsockh.dif"

This process requires that you have almost exactly the same setup as I did, WRT
to compiler version numbers.  My setup consists of a plain DOS/OS2 EMX 0.9d
setup (get it from hobbes, leo, etc.), complemented with RSXNT150.ZIP and
NT09DEMX.ZIP (get it form Rainer Schnitker's web page, see above).  If you have
other versions of these compilers, you'll have to dig yourself.

Finally, copy "Makefile" and "Makefile.dep" from this archive to the binkd
source code directory.  You should now be able to produce a working binkd.exe
executable by simplly typing in "gmake" in the binkd source code directory.

I experienced strange errors on the final linker stage, thins like "ntbind
failed" because of too many open files, even crashes that caused a dialog
box to pop up. Don't let yourself be discouraged by them. Just type "gmake"
again and again, sooner or later the link process will succeed.

Good luck!

In case of problems, visit http://www.physcip.uni-stuttgart.de/tobi/binkd, or
contact me at tobi@bland.fido.de, or Tobias Ernst @ 2:2476/418.

[EOF]